// Exo 3: mots mêlés.

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>
#include <ctype.h>

#define N 10
#define M (2*N)

// La grille sera stockée dans la variable suivante:
char grille[N][N];
//et les mots ici
char mots[M][N];
// et le statut de la grille ici. true == lettre barrée
bool statut[M][N];


/*Initialise le jeu  à partir du fichier fic, ouvert*/
int initialise_jeu(FILE* fic)
{
  int i, j ;
  // Récupération de la grille
  char oneline[N]; // chaine
  for (i=0;i<=N-1;i++)
    {
      // récupération d'une ligne
      fscanf(fic, "%s",oneline);
      // copie de N caractères dans la matrice t, "ligne i"
      strncpy(grille[i],oneline,N);
    }
  // récupération des mots cachés
  // On considère qu'il y au plus 2N mots cachés, on ne vérifie pas.
  int nbmots;
  fscanf(fic, "%d", &nbmots);
  for (i=0;i<=nbmots-1;i++)
    {
      // récupération d'une ligne
      fscanf(fic, "%s",oneline);
      // copie du mot
      strncpy(mots[i],oneline,N);
    }
  // Initialise le tableau de statut de la grille
  for (i=0;i<N;i++){
    for (j=0; j<N; j++)
      statut[i][j]=false;
  }
  
  return nbmots;
}

/*imprime un tableau de chaînes de caractères (tableau 2D)*/
void imprime_chaines(char strtab[M][N], int nbmots){
  int i;
  for (i=0;i<nbmots;i++){
    printf("mot %d: %s, ", i, strtab[i]);
  }
  printf("\n");
}


/*imprime une matrice de caractères*/
void imprime_mat(char t[N][N]){
  int i,j;
  for (i=0;i<N;i++){
    for (j=0;j<N;j++)
      printf("%c,",t[i][j]);
    printf("\n");
  }
}


bool trouve_mot_horizontalementGD(int motindex, int l, int c){
  // Le mot que l'on cherche est mots[motindex]
  // renvoie true si le mot est trouvé horizontalement à partir de l,c
  // dans la grille, false sinon.
  // // AFAIRE
  return false;
}



/*Fonction principale*/
int main(){
  
  FILE* f = fopen("grille.txt","r");
  if (f==NULL){
    printf("Fichier de grille manquant!\n");
    return 1;
  } 
  // Initialisation de la grille, et du tableau contenant les mots à trouver
  int nb = initialise_jeu(f);
  printf("impression de la grille de mots mêlés!\n");
  imprime_mat(grille);
  printf("Il y a %d mots à trouver!\n", nb);
  imprime_chaines(mots, nb);

  // Pour tester votre fonction trouve_mot_horizontalementGD:
  // AFAIRE décommenter cette ligne en remplaçant les ? par des vrais nombres
  // if (trouve_mot_horizontalementGD(17,?,?)) printf("le mot num 17 est trouvé\n");

  
  fclose(f);
  return 0;
}
